package com.jh.boot.document;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;
import org.springframework.util.StringUtils;

import com.jh.boot.jpa.AbstractHibernateRepository;

@Repository
public class LegalDocumentRepository extends AbstractHibernateRepository {

	public LegalDocument findByCodeAndLocale(String code, String locale) {
		if (code == null) {
			return null;
		}
		if (!StringUtils.hasText(locale)) {
			locale = "en";
		}
		
		locale = locale.replace("-", "_");
		
		Query q = entityManager.createQuery("select ld from LegalDocument ld where lower(ld.code) = :code and lower(ld.locale) = :locale");
		q.setParameter("code", code.toLowerCase());
		q.setParameter("locale", locale.toLowerCase());
		
		LegalDocument ld = singleResult(q);
		if (ld == null) {
			if (locale.indexOf('_') > -1) {
				return findByCodeAndLocale(code, locale.substring(0, locale.lastIndexOf('_')));
			} else if (!"en".equalsIgnoreCase(locale)) {
				return findByCodeAndLocale(code, "en");
			}
		}
		
		return ld;
	}
	

}
