/*
 * Created on 8. 8. 2017 8:36:15
 *
 */
package com.jh.boot.email;

import java.util.Base64;
import java.util.Base64.Encoder;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.jh.boot.jpa.AbstractIdEntity;

/**
 * The Class EmailAttachment.
 *
 * @author Jan Hrabal
 */
@Entity
@Table(name = "EMAIL_ATTACHMENT")
public class EmailAttachment extends AbstractIdEntity {
    
	/** The name. */
	@Column(name = "NAME")
    private String name;
    
    /** The mime type. */
    @Column(name = "MIME_TYPE")
    private String mimeType;

    /** The data. */
    //base 64
    @Column(name = "DATA")
    private String data;

    /** The email. */
    @ManyToOne @org.hibernate.annotations.NotFound(action = org.hibernate.annotations.NotFoundAction.IGNORE)
    @JoinColumn(name = "EMAIL_ID")
    @JsonIgnore
    private Email email;
    
	/** The cid. */
	@Column(name = "CID")
    private String cid;
    
    /**
     * Gets the name.
     *
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * Sets the name.
     *
     * @param name the new name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * Gets the mime type.
     *
     * @return the mime type
     */
    public String getMimeType() {
        return mimeType;
    }

    /**
     * Sets the mime type.
     *
     * @param mimeType the new mime type
     */
    public void setMimeType(String mimeType) {
        this.mimeType = mimeType;
    }

    /**
     * Gets the data.
     *
     * @return the data
     */
    public String getData() {
        return data;
    }

    /**
     * Sets the data.
     *
     * @param data the new data
     */
    public void setData(String data) {
        this.data = data;
    }

    /**
     * Sets the data.
     *
     * @param bytes the new data
     */
    public void setData(byte[] bytes) {
    	if (bytes == null || bytes.length == 0) {
    		setData((String) null);
    		return;
    	}
    	
    	Encoder encoder = Base64.getEncoder();
		setData(new String(encoder.encode(bytes)));
    }
    
	/**
	 * Gets the email.
	 *
	 * @return the email
	 */
	public Email getEmail() {
		return email;
	}

	/**
	 * Sets the email.
	 *
	 * @param email the new email
	 */
	public void setEmail(Email email) {
		this.email = email;
	}

	/**
	 * Gets the cid.
	 *
	 * @return the cid
	 */
	public String getCid() {
		return cid;
	}

	/**
	 * Sets the cid.
	 *
	 * @param cid the new cid
	 */
	public void setCid(String cid) {
		this.cid = cid;
	}
}
