package com.jh.boot.email;

import java.net.URI;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpMethod;
import org.springframework.http.RequestEntity;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;

/**
 * The Class RestEmailService.
 */
@SuppressWarnings("unused")
public class RestEmailService implements EmailService {

	/** The rest template. */
	protected RestTemplate restTemplate;

    /** The username. */
    private String username;
	
	/** The password. */
	private String password;
	
	/** The unit id. */
	private String unitId;
	
	/** The url. */
	private String url;

	/** The uri. */
	private URI uri;
	
	
	/**
	 * Inits the.
	 *
	 * @throws Exception the exception
	 */
	@PostConstruct
	public void init() throws Exception {
		uri = new URI(url);
	}

	
	/**
	 * {@inheritDoc}
	 * @see com.jh.module.email.EmailService#sendEmail(com.jh.module.email.Email)
	 */
	@Override
	public Email sendEmail(Email email) {
		//TODO
		RequestEntity<Email> request = new RequestEntity<>(email, HttpMethod.POST, uri);
		ResponseEntity<Email> response = restTemplate.exchange(request, Email.class);
		return email;
	}
	
	
	/**
	 * Sets the rest template.
	 *
	 * @param restTemplate the new rest template
	 */
	@Autowired
	public void setRestTemplate(RestTemplate restTemplate) {
		this.restTemplate = restTemplate;
	}

	/**
	 * Sets the username.
	 *
	 * @param username the new username
	 */
	@Value("${email.username:}")
	public void setUsername(String username) {
		this.username = username;
	}


	/**
	 * Sets the password.
	 *
	 * @param password the new password
	 */
	@Value("${email.password:}")
	public void setPassword(String password) {
		this.password = password;
	}


	/**
	 * Sets the unit id.
	 *
	 * @param unitId the new unit id
	 */
	@Value("${email.unitId:}")
	public void setUnitId(String unitId) {
		this.unitId = unitId;
	}


	/**
	 * Sets the url.
	 *
	 * @param url the new url
	 */
	@Value("${email.url:}")
	public void setUrl(String url) {
		this.url = url;
	}
	
}

/*


'use strict';

const http = require('http');

//TODO
module.exports = function(config = {}) {

    //TODO validate config
    const 
        login = config.login,
        password = config.password,
        unitId = config.unitId,

        hostname = config.hostname || 'localhost',
        port = config.port || 3033,
        path = '/api/email';

    if (!unitId) {
        throw new Error("Parameter unitId is required");
    }


    //TODO
    return function(message) {
        //TODO validate email...
        if (!message) {
            return Promise.reject(new Error("Email is required"));
        }
        
        //TODO
        const email = Object.assign({}, message);
        email.unit_id = unitId;

        //async request
        return new Promise(function(resolve, reject) {
            const postData = JSON.stringify(email);
 
            const options = {
              hostname: hostname,
              port: port,
              path: path,
              method: 'POST',

              headers: {
                'Content-Type': 'application/json;charset=UTF-8',
                'Content-Length': Buffer.byteLength(postData)
              }
            };

            const req = http.request(options, (res) => {
                let resobj = "";

                //res.setEncoding('utf8');
                res.on('data', (chunk) => {
                    resobj += chunk;
                });
                res.on('end', () => {
                    if (res.statusCode > 199 && res.statusCode < 300) {
                        resolve(JSON.parse(resobj));
                    } else {
                        reject(JSON.parse(resobj));
                    }
                });
            });

            req.on('error', (e) => {
              //console.error(`problem with request: ${e.message}`);
              reject(e);
            });

            // write data to request body
            req.write(postData);
            req.end();

        });

    }

}

*/