package com.jh.boot.security;

import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;



/**
 * TODO.
 *
 * @author jh
 */
public interface AuthService {

	/**
	 * Authenticate.
	 *
	 * @param username the username
	 * @param password the password
	 * @return the authentication
	 * @throws BadCredentialsException the bad credentials exception
	 */
	Authentication authenticate(String username, String password) throws BadCredentialsException;
	
	/**
	 * Register.
	 *
	 * @param signup the signup
	 */
	void register(String login, String password) throws AuthenticationException;
	
	
	/**
	 * This method is responsible for creating new reset password request
	 * for provided login (or should do nothing if the login is unknown).
	 * 
	 * <p>The way of letting the user know the token is up to the implementation</p>
	 * 
	 * @param login
	 */
	String generateResetToken(String login);

	/**
	 * TODO
	 * @param resetPassword
	 * @throws AuthenticationException TODO
	 */
	void resetPassword(String login, String token, String newPassword) throws AuthenticationException;
	
	
}
