package com.jh.boot.template.customizable;

import java.util.Collection;
import java.util.List;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import com.jh.boot.jpa.AbstractHibernateRepository;
import com.jh.boot.template.Template;


@Repository
public class CustomizableLabelsRepository extends AbstractHibernateRepository {

	
	@SuppressWarnings("unchecked")
	public Template fetchTemplate(String code) {
		Query q = entityManager.createQuery("select t from Template t where code = :code");
		q.setParameter("code", code);
		List<Template> list = q.getResultList();
		return list.isEmpty() ? null : list.get(0);
	}


	@SuppressWarnings("unchecked")
	public List<TemplateLabel> findCustomizedTemplateLabels(String templateCode, Long unitId) {
		Query q = entityManager.createQuery("select tl from TemplateLabel tl left join tl.template t where t.code = :templateCode and tl.unitId = :unitId order by tl.position asc");
		
		q.setParameter("templateCode", templateCode);
		q.setParameter("unitId", unitId);
		
		return q.getResultList();
	}


	@SuppressWarnings("unchecked")
	public List<TemplateLabel> findDefaultTemplateLabels(String templateCode) {
		Query q = entityManager.createQuery("select tl from TemplateLabel tl left join tl.template t where t.code = :templateCode and tl.unitId is null");
		q.setParameter("templateCode", templateCode);
		return q.getResultList();
	}


	public void saveCustomizedLabels(Collection<TemplateLabel> labels) {
		if (labels == null) {
			return;
		}
		labels.stream().forEach(this::save);
	}



}
