package com.jh.boot.template.customizable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.jh.boot.jpa.AbstractIdEntity;
import com.jh.boot.template.Template;


@Entity
@Table(name = "CUSTOMIZABLE_TEMPLATE_LABEL")
public class TemplateLabel extends AbstractIdEntity {

	@ManyToOne
	@JoinColumn(name="TEMPLATE_ID", nullable=false, updatable=false)
	@JsonIgnore
	private Template template;
	
	@Column(name = "UNIT_ID")
	@JsonIgnore
	private Long unitId; 
	
	@Column(name = "CODE")
	private String code;
	
	@JsonIgnore
	@Column(name = "POSITION")
	private Long position;

	@Column(name = "LANG")
	@JsonIgnore
	private String languageCode;
	
	@Column(name = "LABEL")
	private String label;
	
	
	@Transient
	private String defaultLabel;

	@Transient
	private String defaultLanguageCode;

	public Template getTemplate() {
		return template;
	}

	public void setTemplate(Template template) {
		this.template = template;
	}

	public Long getUnitId() {
		return unitId;
	}

	public void setUnitId(Long unitId) {
		this.unitId = unitId;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public Long getPosition() {
		return position;
	}

	public void setPosition(Long position) {
		this.position = position;
	}

	public String getLanguageCode() {
		return languageCode;
	}

	public void setLanguageCode(String languageCode) {
		this.languageCode = languageCode;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getDefaultLabel() {
		return defaultLabel;
	}

	public void setDefaultLabel(String defaultLabel) {
		this.defaultLabel = defaultLabel;
	}

	public String getDefaultLanguageCode() {
		return defaultLanguageCode;
	}

	public void setDefaultLanguageCode(String defaultLanguageCode) {
		this.defaultLanguageCode = defaultLanguageCode;
	}

	@Override
	public String toString() {
		return "unitId=" + unitId + ", code=" + code + ", languageCode=" + languageCode + ", label=" + label;
	}
	
	
	
}
